function [fval,gradient] = datamerge(gamma,utilityData04,utilityData05,utilityData06,utilityData07,schoolQuality04,schoolQuality05,schoolQuality06,schoolQuality07,J04,J05,J06,J07);
%%Aggregating the negative log-likelihood and gradient over the four school years in the data 


k = max(size(gamma));
numreg = 23;

%Creating Log-Likelihood for each year
[fval04,gradient04] = dataread2(utilityData04,[gamma(1:numreg);gamma((numreg+ 1):(numreg+J04))],schoolQuality04);
[fval05,gradient05] = dataread2(utilityData05,[gamma(1:numreg);gamma((numreg+ J04 + 1):(numreg+J04 + J05))],schoolQuality05);
[fval06,gradient06] = dataread2(utilityData06,[gamma(1:numreg);gamma((numreg+ J04 + J05 +1):(numreg+J04 + J05 + J06))],schoolQuality06);
[fval07,gradient07] = dataread2(utilityData07,[gamma(1:numreg);gamma((numreg+ J04 + J05 + J06 +1):(numreg+J04 + J05 + J06 + J07))],schoolQuality07);

%Summing the log-likelihoods and gradient (for "non-fixed-effect" terms) over years
fval = fval04 + fval05 + fval06 + fval07;
gradient = zeros(k,1);

%%Plugging in the fixed effect gradients for each school year into the proper position for the overall gradient
gradient(1:numreg) = gradient04(1:numreg) + gradient05(1:numreg) + gradient06(1:numreg) + gradient07(1:numreg);
gradient((numreg+ 1):(numreg+J04)) = gradient04((numreg+1):end);
gradient((numreg+ J04 + 1):(numreg+J04 + J05)) = gradient05((numreg+1):end);
gradient((numreg+ J04 + J05 +1):(numreg+J04 + J05 + J06)) = gradient06((numreg+1):end);
gradient((numreg+ J04 + J05 + J06 +1):(numreg+J04 + J05 + J06 + J07)) = gradient07((numreg+1):end);