function gradient_term = gradient_create2(gamma,responseMatrix,regressors,varMat,choiceInd,weights,probLog,probSim,group04,group05,group06,group07,randsidGroup,J04,J05,J06,J07);
%%%%%%%%%%%%%%%%%%%%%%%%Gradient stuff%%%%%%%%%%%%%%%%%%%%%%%%
%%All variables have an additional dimension of 4, for 2004,2005,2006,2007
%%probSim is a Tx1 matrix of the full probability (with random coefficients) that student t attends schools j,k,o,p, for the actually attended schools

%%Initializing variables
T = size(responseMatrix{1},1);
J = J04 + J05 + J06 + J07;
R = max(size(weights));
size_gamma = max(size(gamma));
gradient_term = zeros(size_gamma,1);

%%%%%%%%CREATING term_reg and term_var%%%%%%%%%
for t=1:T
term_reg = cell(4,1);
term_reg{1} = squeeze(sum(repmat(reshape(regressors{1}(t,:,:),[J04 1 (size_gamma-J-4)]),[1 R 1]).*repmat(reshape(probLog{1}(t,:,:),[J04 R 1]),[1 1 (size_gamma-J-4)]).*repmat(reshape(choiceInd{1}(t,:),[J04 1 1]),[1 R (size_gamma-J-4)]),1));
term_reg{2} = squeeze(sum(repmat(reshape(regressors{2}(t,:,:),[J05 1 (size_gamma-J-4)]),[1 R 1]).*repmat(reshape(probLog{2}(t,:,:),[J05 R 1]),[1 1 (size_gamma-J-4)]).*repmat(reshape(choiceInd{2}(t,:),[J05 1 1]),[1 R (size_gamma-J-4)]),1));
term_reg{3} = squeeze(sum(repmat(reshape(regressors{3}(t,:,:),[J06 1 (size_gamma-J-4)]),[1 R 1]).*repmat(reshape(probLog{3}(t,:,:),[J06 R 1]),[1 1 (size_gamma-J-4)]).*repmat(reshape(choiceInd{3}(t,:),[J06 1 1]),[1 R (size_gamma-J-4)]),1));
term_reg{4} = squeeze(sum(repmat(reshape(regressors{4}(t,:,:),[J07 1 (size_gamma-J-4)]),[1 R 1]).*repmat(reshape(probLog{4}(t,:,:),[J07 R 1]),[1 1 (size_gamma-J-4)]).*repmat(reshape(choiceInd{4}(t,:),[J07 1 1]),[1 R (size_gamma-J-4)]),1));

term_var = cell(4,1);
term_var{1} = squeeze(sum(reshape(varMat{1}(t,:,:,:),[J04 R 4]).*repmat(reshape(probLog{1}(t,:,:),[J04 R 1]),[1 1 4]).*repmat(reshape(choiceInd{1}(t,:),[J04 1 1]),[1 R 4]),1));
term_var{2} = squeeze(sum(reshape(varMat{2}(t,:,:,:),[J05 R 4]).*repmat(reshape(probLog{2}(t,:,:),[J05 R 1]),[1 1 4]).*repmat(reshape(choiceInd{2}(t,:),[J05 1 1]),[1 R 4]),1));
term_var{3} = squeeze(sum(reshape(varMat{3}(t,:,:,:),[J06 R 4]).*repmat(reshape(probLog{3}(t,:,:),[J06 R 1]),[1 1 4]).*repmat(reshape(choiceInd{3}(t,:),[J06 1 1]),[1 R 4]),1));
term_var{4} = squeeze(sum(reshape(varMat{4}(t,:,:,:),[J07 R 4]).*repmat(reshape(probLog{4}(t,:,:),[J07 R 1]),[1 1 4]).*repmat(reshape(choiceInd{4}(t,:),[J07 1 1]),[1 R 4]),1));

	for j=1:J04
		if (responseMatrix{1}(t,j)>0)
	for k=1:J05
		if (responseMatrix{2}(t,k)>0)
	for o=1:J06
		if (responseMatrix{3}(t,o)>0)
	for p=1:J07
		if(responseMatrix{4}(t,p)>0)
			probLog4 = probLog{1}(t,j,:).*probLog{2}(t,k,:).*probLog{3}(t,o,:).*probLog{4}(t,p,:);
			probLog4 = reshape(probLog4,[R 1]).*reshape(weights,[R 1]);
			for i=1:(size_gamma-J-4)
gradient_term(i,1) = gradient_term(i,1) ...
 + sum(ismember(randsidGroup(t),group04)*(1/probSim(t))*probLog4.*(regressors{1}(t,j,i) - term_reg{1}(:,i))) ...
 + sum(ismember(randsidGroup(t),group05)*(1/probSim(t))*probLog4.*(regressors{2}(t,k,i) - term_reg{2}(:,i))) ... 
 + sum(ismember(randsidGroup(t),group06)*(1/probSim(t))*probLog4.*(regressors{3}(t,o,i) - term_reg{3}(:,i))) ... 
 + sum(ismember(randsidGroup(t),group07)*(1/probSim(t))*probLog4.*(regressors{4}(t,p,i) - term_reg{4}(:,i)));
			end

			for i=(size_gamma-J-3):(size_gamma-J)
				n = i-size_gamma+J+4;
gradient_term(i,1) = gradient_term(i,1) ... 
+ sum(ismember(randsidGroup(t),group04)*(1/probSim(t))*probLog4.*(reshape(varMat{1}(t,j,:,n),[R 1]) - term_var{1}(:,n))) ...
+ sum(ismember(randsidGroup(t),group05)*(1/probSim(t))*probLog4.*(reshape(varMat{2}(t,k,:,n),[R 1]) - term_var{2}(:,n))) ...
+ sum(ismember(randsidGroup(t),group06)*(1/probSim(t))*probLog4.*(reshape(varMat{3}(t,o,:,n),[R 1]) - term_var{3}(:,n))) ...
+ sum(ismember(randsidGroup(t),group07)*(1/probSim(t))*probLog4.*(reshape(varMat{4}(t,p,:,n),[R 1]) - term_var{4}(:,n)));
            end

			for i=(size_gamma-J+1):size_gamma
				m = i - size_gamma + J;
				if(m<=J04)
gradient_term(i,1) = gradient_term(i,1)... 
+ sum(ismember(randsidGroup(t),group04)*choiceInd{1}(t,m).*(1/probSim(t))*probLog4.*((m==j) - reshape(probLog{1}(t,m,:),[R 1])));
				end

				if((m>J04) && (m<=(J04+J05)))
					m2 = m - J04;
gradient_term(i,1) = gradient_term(i,1)... 
+ sum(ismember(randsidGroup(t),group05)* choiceInd{2}(t,m2).*(1/probSim(t)).*probLog4.*((m2==k) - reshape(probLog{2}(t,m2,:),[R 1])));
				end

				if((m>(J04+J05)) && (m<=(J04+J05+J06)))
					m2 = m - (J04+J05);
gradient_term(i,1) = gradient_term(i,1)... 
+ sum(ismember(randsidGroup(t),group06)*choiceInd{3}(t,m2).*(1/probSim(t)).*probLog4.*((m2==o) - reshape(probLog{3}(t,m2,:),[R 1])));
				end

				if((m>(J04+J05+J06)) && (m<=(J04+J05+J06+J07)))
					m2 = m - (J04+J05+J06);
gradient_term(i,1) = gradient_term(i,1)... 
+ sum(ismember(randsidGroup(t),group07)*choiceInd{4}(t,m2).*(1/probSim(t)).*probLog4.*((m2==p) - reshape(probLog{4}(t,m2,:),[R 1])));
				end
			end						
		end
	end
	end
	end
	end
	end
	end
	end
end

end
