%%%Creating subset of observations where there is no initial conditions problem
    %%This script file subsets the data such that we keep students where:
    % 1) In 2004, moving_costs = 1 for all schools or moving_costs = 0 for all schools (sd(moving_cost_2004)=0)
    % 2) Not in 2004 dataset, and sd(moving_cost_2005) = 0
    % 3) Not in 2004 and 2005 datasets, and sd(moving_cost_2006) = 0 
    % 3) Not in 2004, 2005, and 2006 datasets, and sd(moving_cost_2007) = 0 

    function randnoinitial =  data_no_initial(subsample304,subsample305,subsample306,subsample307,group04,group05,group06,group07,randsid);

    T = max(size(randsid));

    randnoinitial = -1*ones(T,1);

    for t = 1:T
        indextemp = randsid(t);
        
        if(ismember(indextemp,group04)==1)
            moving_temp = subsample304(indextemp==subsample304(:,19),7);
            if(max(size(unique(moving_temp)))==1)
                randnoinitial(t) = indextemp;
            end
        end
        
        if(ismember(indextemp,group04)==0 && ismember(indextemp,group05)==1)
            moving_temp = subsample305(indextemp==subsample305(:,19),7);
            if(max(size(unique(moving_temp)))==1)
                randnoinitial(t) = indextemp;
            end
        end
        
        if(ismember(indextemp,group04)==0 && ismember(indextemp,group05)==0 && ismember(indextemp,group06)==1)
            moving_temp = subsample306(indextemp==subsample306(:,19),7);
            if(max(size(unique(moving_temp)))==1)
                randnoinitial(t) = indextemp;
            end
        end
    
        if(ismember(indextemp,group04)==0 && ismember(indextemp,group05)==0 && ismember(indextemp,group06)==0 && ismember(indextemp,group07)==1)
            moving_temp = subsample307(indextemp==subsample307(:,19),7);
            if(max(size(unique(moving_temp)))==1)
                randnoinitial(t) = indextemp;
            end
        end

    end
    
    randnoinitial = randnoinitial(randnoinitial>=0);
    
end