function [regressors,responseMatrix,varMat,choiceInd] = datamergeRand_setup(beta,subsample304,subsample305,subsample306,subsample307,schoolQuality04,schoolQuality05,schoolQuality06,schoolQuality07,choiceSet04,choiceSet05,choiceSet06,choiceSet07,group04,group05,group06,group07,randsid);
%%This file creates the regressors, school choice (read: response) matrix, and choice sets in a format that can be fed into the estimation code
%%Saves time relative to formating the variables each time the likelihood function is calculated

%%%Reading in quadrature-based approach to integrating over the random coefficients
R1 = 9;
R2 = 9;  %matlabpool number
R = R1*R2;
nDim = 4;  %Number of random coefficients to integrate over
acc = 4;  %Will be exact for polynomials up to 2*acc - 1 

[nodes, weights] = nwspgr('KPN',nDim,acc);  %This is for normal weights as needed, not Gaussian weights (checked moments)

%%%Initializing number of students, number of school choices, number of parameters, etc.
T = max(size(randsid));

J04 = max(size(choiceSet04));
J05 = max(size(choiceSet05));
J06 = max(size(choiceSet06));
J07 = max(size(choiceSet07));
J = J04 + J05 + J06 + J07;

size_gamma = max(size(beta));
numReg=size_gamma-J;
numRegP1=size_gamma-J+1;

%%%%%%%%%%%%%%%%%%%%%%%%Creating the matrices for each school year necessary to calculate the negative log-likelihood and the gradient of the negative log-likelihood%%%%%%%%%%%%%%%%%%%%%%
regressors = cell(4,1);
responseMatrix = cell(4,1);
varMat = cell(4,1);
choiceInd = cell(4,1);

[regressors04,varMat04,choiceInd04,responseMatrix04] = yeardata_setup(subsample304,beta([1:numReg,numRegP1:(J04+numReg)]),schoolQuality04,group04,randsid);
regressors{1} = regressors04;
responseMatrix{1} = responseMatrix04;
varMat{1} = varMat04;
choiceInd{1} = choiceInd04;
clear subsample304 probLog04 regressors04 responseMatrix04 varMat04 choiceInd04

[regressors05,varMat05,choiceInd05,responseMatrix05] = yeardata_setup(subsample305,beta([1:numReg,(J04+numRegP1):(J04+J05+numReg)]),schoolQuality05,group05,randsid);
regressors{2} = regressors05;
responseMatrix{2} = responseMatrix05;
varMat{2} = varMat05;
choiceInd{2} = choiceInd05;
clear subsample305 probLog05 regressors05 responseMatrix05 varMat05 choiceInd05

[regressors06,varMat06,choiceInd06,responseMatrix06] = yeardata_setup(subsample306,beta([1:numReg,(J04+J05+numRegP1):(J04+J05+J06+numReg)]),schoolQuality06,group06,randsid);
regressors{3} = regressors06;
responseMatrix{3} = responseMatrix06;
varMat{3} = varMat06;
choiceInd{3} = choiceInd06;
clear subsample306 probLog06 regressors06 responseMatrix06 varMat06 choiceInd06

[regressors07,varMat07,choiceInd07,responseMatrix07] = yeardata_setup(subsample307,beta([1:numReg,(J04+J05+J06+numRegP1):(J04+J05+J06+J07+numReg)]),schoolQuality07,group07,randsid);
regressors{4} = regressors07;
responseMatrix{4} = responseMatrix07;
varMat{4} = varMat07;
choiceInd{4} = choiceInd07;
clear subsample307 probLog07 regressors07 responseMatrix07 varMat07 choiceInd07
end