function probLog = randLogQuadYearNum(gamma,regressors,varMat,choiceInd,responseMatrix,T,J,J2,J3,R1,R2);
%%This code simply calculates the conditional logit probability for a given value of the random coefficients

R = R1*R2;
k = max(size(gamma));

vNom = squeeze(sum(bsxfun(@times,regressors,reshape(gamma(1:(k-J-4)),[1 1 k-J-4])),3)) + repmat(reshape(gamma((k-J+J3+1):(k-J+J3+J2)),[1 J2]),[T 1]);
clear regressors

%%Creating and Adding in variance terms
v = bsxfun(@plus,vNom,sqrt(gamma(k-J-3)^2)*varMat(:,:,:,1)  + sqrt(gamma(k-J-2)^2)*varMat(:,:,:,2) + sqrt(gamma(k-J-1)^2)*varMat(:,:,:,3) + sqrt(gamma(k-J)^2)*varMat(:,:,:,4));
clear varMat

temp=zeros(T,J2,R);

for n=1:J2
    for m=1:J2
        temp(:,n,:) = temp(:,n,:) + exp(v(:,m,:) - v(:,n,:)).*repmat(reshape(choiceInd(:,m),[T 1 1]),[1 1 R]);
    end
    temp(:,n,:) = temp(:,n,:).*repmat(reshape(choiceInd(:,n),[T 1 1]),[1 1 R]);
end

probLog = 1./temp;		
probLog(probLog==Inf) = 0;

end