function [regressors,varMat,choiceInd] = randLogQuadYearNum_setup(gamma,nodes1,nodes2,nodes3,nodes4,weights,responseMatrix,net_income,raceBlack,FRL,school_FRL,school_Black,school_Ability,ability,moving_costs,travel_costs,gradeMinInd,gradeMaxInd,indUnavail,privateInd,leaveInd,grade,everGifted,everSpecEd,susp_days,school_Gifted,school_SpecEd,school_susp,T,J,R1,R2);
%%Creating the regressors and set of possible school choices for calculating conditional logit probabilities for a given school year for a given value of the random coefficients


R = R1*R2;
k = max(size(gamma));
regressors = zeros(T,J,k-J-4);

regressors(:,:,1) = school_Ability.*ability;
regressors(:,:,2) = school_Ability.*raceBlack;
regressors(:,:,3) = school_Ability.*FRL;
regressors(:,:,4) = school_Black.*ability;
regressors(:,:,5) = school_Black.*raceBlack;
regressors(:,:,6) = school_Black.*FRL;
regressors(:,:,7) = school_FRL.*ability;
regressors(:,:,8) = school_FRL.*raceBlack;
regressors(:,:,9) = school_FRL.*FRL;
regressors(:,:,10) = school_FRL.*susp_days;
regressors(:,:,11) = school_susp.*ability;
regressors(:,:,12) = school_susp.*raceBlack;
regressors(:,:,13) = school_susp.*FRL;
regressors(:,:,14) = school_susp.*susp_days;
regressors(:,:,15) = moving_costs;
regressors(:,:,16) = moving_costs.*ability;
regressors(:,:,17) = moving_costs.*raceBlack;
regressors(:,:,18) = moving_costs.*FRL;
regressors(:,:,19) = moving_costs.*susp_days;
regressors(:,:,20) = travel_costs;
regressors(:,:,21) = travel_costs.*ability;
regressors(:,:,22) = travel_costs.*raceBlack;
regressors(:,:,23) = travel_costs.*FRL;


choiceInd = (1-gradeMinInd).*(1-gradeMaxInd).*(1-indUnavail);

varMat = zeros(T,J,R,4);
varMat(:,:,:,1) = bsxfun(@times,school_Ability,reshape(nodes1,[1 1 R]));
varMat(:,:,:,2) = bsxfun(@times,school_FRL,reshape(nodes2,[1 1 R]));
varMat(:,:,:,3) = bsxfun(@times,school_Black,reshape(nodes3,[1 1 R]));
varMat(:,:,:,4) = bsxfun(@times,school_susp,reshape(nodes4,[1 1 R]));
end