##Loading Libraries
library(MASS)
library(AER)

##Based on Equation (3) in the paper, want to create plots for school_Black, school_FRL, school_Ability, school_susp
##Will use this order for variables: school_Ability, school_Black, school_FRL, school_susp

path = "/Users/jha/Dropbox/SCP/"

gamma = read.table(paste(path,"results/gammaDynamic_noinitial50.txt",sep=""),header=F)
k = max(dim(gamma))
school_FE = gamma[(23 + 4 + 1):k,1]

regression_var = read.table(paste(path,"results/regression_var.csv",sep=""),header=T,sep=",")
regression_var = regression_var[!is.na(regression_var[,3]),]
N = max(dim(regression_var))

X1 = cbind(regression_var$Actclunchcode,regression_var$Actcracecode,regression_var$Actind_ability,regression_var$Actsuspension_days)
X2 = cbind(matrix(1,N,1),regression_var$elem,regression_var$middle)
X = cbind(X1,X2)

Z1 = cbind(regression_var$Feederclunchcode,regression_var$Feedercracecode,regression_var$Feederind_ability,regression_var$Feedersuspension_days)
Z = cbind(Z1,X2)

index= !is.na(Z[,4])

betacoef = ivreg.fit(X[index==1,],school_FE[index==1],Z[index==1,])

main_effects = c(-3.976,-4.037,0.807,-0.19)  #FRL, Black, Achievement, Susp

var_terms = c(sqrt(gamma[24,1]^2),sqrt(gamma[25,1]^2),sqrt(gamma[26,1]^2),sqrt(gamma[27,1]^2))

setwd(paste(path,"data/",sep=""))

utilityData04 = read.table("utilityData04.csv",header=F,sep=",")
obsData04 = utilityData04[utilityData04[,3]==1,]
remove(utilityData04)

colnames(obsData04) = c("choiceRep","grade","indAttended","FRL","raceBlack","raceOther","moving_costs","driving_times","group","ability_index","ind_ability","school_FRL","school_Black","school_Ability","","net_income","gradeMin","gradeMax","randsid","magnetapplied","oversubscribed","everGifted","allSchools","female","inflowInd","ALAInd","closedInd","everSpecEd","offenses","susp_days")

normal_draws04 = mvrnorm(n = length(obsData04$ind_ability), matrix(0,4,1), diag(4), tol = 1e-6, empirical = FALSE, EISPACK = FALSE)

##For schoolAbility
betaAbility04 = main_effects[3] + gamma[1,1]*obsData04$ind_ability + gamma[2,1]*obsData04$raceBlack + gamma[3,1]*obsData04$FRL + var_terms[1]*normal_draws04[,1]

##For schoolBlack
betaBlack04 = main_effects[2] + gamma[4,1]*obsData04$ind_ability + gamma[5,1]*obsData04$raceBlack + gamma[6,1]*obsData04$FRL + var_terms[3]*normal_draws04[,3]

##For schoolFRL
betaFRL04 = main_effects[1] + gamma[7,1]*obsData04$ind_ability + gamma[8,1]*obsData04$raceBlack + gamma[9,1]*obsData04$FRL + gamma[10,1]*obsData04$susp_days + var_terms[2]*normal_draws04[,2]

##For school_susp
betasusp04 = main_effects[4] + gamma[11,1]*obsData04$ind_ability + gamma[12,1]*obsData04$raceBlack + gamma[13,1]*obsData04$FRL + gamma[14,1]*obsData04$susp_days + var_terms[4]*normal_draws04[,4]

#For moving_costs
betamoving04 = gamma[15,1] + gamma[16,1]*obsData04$ind_ability + gamma[17,1]*obsData04$raceBlack + gamma[18,1]*obsData04$FRL + gamma[19,1]*obsData04$susp_days

#For travel_costs
betatravel04 = gamma[20,1] + gamma[21,1]*obsData04$ind_ability + gamma[22,1]*obsData04$raceBlack + gamma[23,1]*obsData04$FRL


utilityData05 = read.table("utilityData05.csv",header=F,sep=",")
obsData05 = utilityData05[utilityData05[,3]==1,]
remove(utilityData05)

colnames(obsData05) = c("choiceRep","grade","indAttended","FRL","raceBlack","raceOther","moving_costs","driving_times","group","ability_index","ind_ability","school_FRL","school_Black","school_Ability","","net_income","gradeMin","gradeMax","randsid","magnetapplied","oversubscribed","everGifted","allSchools","female","inflowInd","ALAInd","closedInd","everSpecEd","offenses","susp_days")

normal_draws05 = mvrnorm(n = length(obsData05$ind_ability), matrix(0,4,1), diag(4), tol = 1e-6, empirical = FALSE, EISPACK = FALSE)

##For schoolAbility
betaAbility05 = main_effects[3] + gamma[1,1]*obsData05$ind_ability + gamma[2,1]*obsData05$raceBlack + gamma[3,1]*obsData05$FRL + var_terms[1]*normal_draws05[,1]

##For schoolBlack
betaBlack05 = main_effects[2] + gamma[4,1]*obsData05$ind_ability + gamma[5,1]*obsData05$raceBlack + gamma[6,1]*obsData05$FRL + var_terms[3]*normal_draws05[,3]

##For schoolFRL
betaFRL05 = main_effects[1] + gamma[7,1]*obsData05$ind_ability + gamma[8,1]*obsData05$raceBlack + gamma[9,1]*obsData05$FRL + gamma[10,1]*obsData05$susp_days + var_terms[2]*normal_draws05[,2]

##For school_susp
betasusp05 = main_effects[4] + gamma[11,1]*obsData05$ind_ability + gamma[12,1]*obsData05$raceBlack + gamma[13,1]*obsData05$FRL + gamma[14,1]*obsData05$susp_days + var_terms[4]*normal_draws05[,4]

#For moving_costs
betamoving05 = gamma[15,1] + gamma[16,1]*obsData05$ind_ability + gamma[17,1]*obsData05$raceBlack + gamma[18,1]*obsData05$FRL + gamma[19,1]*obsData05$susp_days

#For travel_costs
betatravel05 = gamma[20,1] + gamma[21,1]*obsData05$ind_ability + gamma[22,1]*obsData05$raceBlack + gamma[23,1]*obsData05$FRL

utilityData06 = read.table("utilityData06.csv",header=F,sep=",")
obsData06 = utilityData06[utilityData06[,3]==1,]
remove(utilityData06)

colnames(obsData06) = c("choiceRep","grade","indAttended","FRL","raceBlack","raceOther","moving_costs","driving_times","group","ability_index","ind_ability","school_FRL","school_Black","school_Ability","","net_income","gradeMin","gradeMax","randsid","magnetapplied","oversubscribed","everGifted","allSchools","female","inflowInd","ALAInd","closedInd","everSpecEd","offenses","susp_days")

normal_draws06 = mvrnorm(n = length(obsData06$ind_ability), matrix(0,4,1), diag(4), tol = 1e-6, empirical = FALSE, EISPACK = FALSE)

##For schoolAbility
betaAbility06 = main_effects[3] + gamma[1,1]*obsData06$ind_ability + gamma[2,1]*obsData06$raceBlack + gamma[3,1]*obsData06$FRL + var_terms[1]*normal_draws06[,1]

##For schoolBlack
betaBlack06 = main_effects[2] + gamma[4,1]*obsData06$ind_ability + gamma[5,1]*obsData06$raceBlack + gamma[6,1]*obsData06$FRL + var_terms[3]*normal_draws06[,3]

##For schoolFRL
betaFRL06 = main_effects[1] + gamma[7,1]*obsData06$ind_ability + gamma[8,1]*obsData06$raceBlack + gamma[9,1]*obsData06$FRL + gamma[10,1]*obsData06$susp_days + var_terms[2]*normal_draws06[,2]

##For school_susp
betasusp06 = main_effects[4] + gamma[11,1]*obsData06$ind_ability + gamma[12,1]*obsData06$raceBlack + gamma[13,1]*obsData06$FRL + gamma[14,1]*obsData06$susp_days + var_terms[4]*normal_draws06[,4]

#For moving_costs
betamoving06 = gamma[15,1] + gamma[16,1]*obsData06$ind_ability + gamma[17,1]*obsData06$raceBlack + gamma[18,1]*obsData06$FRL + gamma[19,1]*obsData06$susp_days

#For travel_costs
betatravel06 = gamma[20,1] + gamma[21,1]*obsData06$ind_ability + gamma[22,1]*obsData06$raceBlack + gamma[23,1]*obsData06$FRL

utilityData07 = read.table("utilityData07.csv",header=F,sep=",")
obsData07 = utilityData07[utilityData07[,3]==1,]
remove(utilityData07)

colnames(obsData07) = c("choiceRep","grade","indAttended","FRL","raceBlack","raceOther","moving_costs","driving_times","group","ability_index","ind_ability","school_FRL","school_Black","school_Ability","","net_income","gradeMin","gradeMax","randsid","magnetapplied","oversubscribed","everGifted","allSchools","female","inflowInd","ALAInd","closedInd","everSpecEd","offenses","susp_days")

normal_draws07 = mvrnorm(n = length(obsData07$ind_ability), matrix(0,4,1), diag(4), tol = 1e-6, empirical = FALSE, EISPACK = FALSE)

##For schoolAbility
betaAbility07 = main_effects[3] + gamma[1,1]*obsData07$ind_ability + gamma[2,1]*obsData07$raceBlack + gamma[3,1]*obsData07$FRL + var_terms[1]*normal_draws07[,1]

##For schoolBlack
betaBlack07 = main_effects[2] + gamma[4,1]*obsData07$ind_ability + gamma[5,1]*obsData07$raceBlack + gamma[6,1]*obsData07$FRL + var_terms[3]*normal_draws07[,3]

##For schoolFRL
betaFRL07 = main_effects[1] + gamma[7,1]*obsData07$ind_ability + gamma[8,1]*obsData07$raceBlack + gamma[9,1]*obsData07$FRL + gamma[10,1]*obsData07$susp_days + var_terms[2]*normal_draws07[,2]

##For school_susp
betasusp07 = main_effects[4] + gamma[11,1]*obsData07$ind_ability + gamma[12,1]*obsData07$raceBlack + gamma[13,1]*obsData07$FRL + gamma[14,1]*obsData07$susp_days + var_terms[4]*normal_draws07[,4]

#For moving_costs
betamoving07 = gamma[15,1] + gamma[16,1]*obsData07$ind_ability + gamma[17,1]*obsData07$raceBlack + gamma[18,1]*obsData07$FRL + gamma[19,1]*obsData07$susp_days

#For travel_costs
betatravel07 = gamma[20,1] + gamma[21,1]*obsData07$ind_ability + gamma[22,1]*obsData07$raceBlack + gamma[23,1]*obsData07$FRL

##Creating lists to loop through for the graphs
betas = list()
betas[[1]] = c(betaAbility04,betaAbility05,betaAbility06,betaAbility07)
betas[[2]] = c(betaBlack04,betaBlack05,betaBlack06,betaBlack07)
betas[[3]] = c(betaFRL04,betaFRL05,betaFRL06,betaFRL07)
betas[[4]] = c(betasusp04,betasusp05,betasusp06,betasusp07)
betas[[5]] = c(betamoving04,betamoving05,betamoving06,betamoving07)
betas[[6]] = c(betatravel04,betatravel05,betatravel06,betatravel07)

beta_name = c("Achievement","Black","FRL","Suspension Days","Moving Costs","Travel Times")

##Creating colors to differentiate Black=0 versus 1 and FRL=0 versus 1
colorsBlack = c(obsData04$raceBlack,obsData05$raceBlack,obsData06$raceBlack,obsData07$raceBlack)
colorsFRL = c(obsData04$FRL,obsData05$FRL,obsData06$FRL,obsData07$FRL)

##Graphs are for each peer measure (ex: FRL, Black, ...) with 4 panels with the different years
pdf(paste(path,"results/school_Coefs50.pdf",sep=""))
for(i in 1:6){
	if(beta_name[i]=="Black"){ 
		p1 = hist(betas[[i]][colorsBlack==0],breaks=15,main=paste(beta_name[i]," Coefficient Distribution, =0",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		p2 = hist(betas[[i]][colorsBlack==1],breaks=15,main=paste(beta_name[i]," Coefficient Distribution, =1",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		plot(p1, col=rgb(1,1,1,1/4),xlim=c(min(betas[[i]])-0.5,max(betas[[i]])+0.5),main=paste(beta_name[i]," Coefficient Distribution, All Years",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))  # first histogram 
		plot(p2, col=rgb(0,0,0,1/4), add=T)  # second histogram
	}

	else if(beta_name[i]=="FRL"){
		p1 = hist(betas[[i]][colorsFRL==0],breaks=15,main=paste(beta_name[i]," Coefficient Distribution, =0",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		p2 = hist(betas[[i]][colorsFRL==1],breaks=15,main=paste(beta_name[i]," Coefficient Distribution, =1",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		plot(p1, col=rgb(1,1,1,1/4),xlim=c(min(betas[[i]])-0.5,max(betas[[i]])+0.5),main=paste(beta_name[i]," Coefficient Distribution, All Years",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))  # first histogram 
		plot(p2, col=rgb(0,0,0,1/4), add=T)  # second histogram
	}

	else{
		hist(betas[[i]],breaks=15,main=paste(beta_name[i]," Coefficient Distribution, All Years",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
	}
}
dev.off()

pdf(paste(path,"results/schoolCoefs_truncated50.pdf",sep=""))
for(i in 1:4){
	if(beta_name[i]=="Black"){ 
		p1 = hist(betas[[i]][colorsBlack==0 & betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)],breaks=15,main=paste(beta_name[i]," Coef Dist Middle 90, =0",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		p2 = hist(betas[[i]][colorsBlack==1 & betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)],breaks=15,main=paste(beta_name[i]," Coef Dist Middle 90, =1",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		plot(p1, col=rgb(1,1,1,1/4),xlim=c(min(betas[[i]][betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)]-0.5),max(betas[[i]][betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)])+0.5),main=paste(beta_name[i]," Coef Dist Middle 90, All Years",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))  # first histogram 
		plot(p2, col=rgb(0,0,0,1/4), add=T)  # second histogram
	}

	else if(beta_name[i]=="FRL"){
		p1 = hist(betas[[i]][colorsFRL==0 & betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)],breaks=15,main=paste(beta_name[i]," Coef Dist Middle 90, =0",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		p2 = hist(betas[[i]][colorsFRL==1 & betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)],breaks=15,main=paste(beta_name[i]," Coef Dist Middle 90, =1",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
		plot(p1, col=rgb(1,1,1,1/4),xlim=c(min(betas[[i]][betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)]-0.5),max(betas[[i]][betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)])+0.5),main=paste(beta_name[i]," Coef Dist Middle 90, All Years",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))  # first histogram 
		plot(p2, col=rgb(0,0,0,1/4), add=T)  # second histogram
	}

	else{
		hist(betas[[i]][betas[[i]]>=quantile(betas[[i]],0.1) & betas[[i]]<=quantile(betas[[i]],0.9)],breaks=15,main=paste(beta_name[i]," Coef Dist Middle 90, All Years",sep=""),xlab=paste(beta_name[i]," Coefficient",sep=""))
	}
}
dev.off()